%our friend Least squares

%Mock data
close all; clear
N=250; lm=0.1;
x=8*rand(N,1)+1; y=2*sin(3*x)+0.5*sin(5*x)+0.75*sin(9*x)+0.02*randn(N,1);

for d=1:15
    X=ones(N,1); %d=1; %d is degree polyomial fit
    for i=1:d
        %X=[X x.^i];
        X=[X sin(i.*x)]
    end
    Y=y;

    %x = A\B solves the system of linear equations A*x = B.
    b1=X\Y;
    b4=pinv(X)*Y
    bL=lasso(X,Y,'lambda',1.e-2)


    %ridge-Tikohonov version
    XX=[X; sqrt(lm)*eye(d+1,d+1)]; 
    YY=[Y;zeros(d+1,1)];
    b7=pinv(XX)*YY;
    b=b4;

    %X*b
    yy=X*b;
    %norm(X*b-Y);
    %norm(XX*b-YY);

    plot(x,y,'.'); xlabel('x'); ylabel('y');
    [xx,i]=sort(x);
    hold on; plot(x,yy,'*r'); plot(xx,yy(i),'r'); 
    yyy=X*b7; plot(x,yyy,'*r'); plot(xx,yyy(i),'g');  hold off
    vb=[b1 b4 b7 
        bL]
    d
    pause
end
