%our friend Least squares

%Mock data
close all; clear
N=100; lm=0.1;
x=8*rand(N,1)+1; y=2*sin(x)+1.*randn(N,1);
k=1000; l=90; maxPorder=30;

meanrestrain=zeros(maxPorder,1); meanrestest=zeros(maxPorder,1);
for d=1:maxPorder
    %figure
    for j=1:k
        index=randperm(N); indextrain=index(1:l); indextest=index(l+1:end);
        X=ones(N,1); %d=1; %d is degree polyomial fit
        for i=1:d
            X=[X x.^i];
        end
        Xtr=X(indextrain,:); Xtest=X(indextest,:); %xtest=X(indextest,:)
        Ytr=y(indextrain,:); Ytest=y(indextest,:); 

        %x = A\B solves the system of linear equations A*x = B.
%         b1=Xtr\Ytr;
%         b2=lsqminnorm(Xtr,Ytr);
%         b3=inv(Xtr'*Xtr)*Xtr'*Ytr;
        b4=pinv(Xtr)*Ytr;
        b=b4;

        %test on train
        yy=Xtr*b;
        e1=norm(Xtr*b-Ytr)
        meanrestrain(d)=meanrestrain(d)+e1;%/l;

        %test on outof sample
        yy=Xtest*b;
        e2=norm(Xtest*b-Ytest)
        meanrestest(d)=meanrestest(d)+e2;%/l;

%      plot(x,y,'.'); xlabel('x'); ylabel('y');
%      [xx,i]=sort(x);
%     hold on; plot(xtest,yy,'*r'); %plot(xxtest,yy(i),'r'); 

        %yyy=X*b6; plot(x,yyy,'*r'); plot(xx,yyy(i),'g');  hold off
        %vb=[b1 b2 b3 b4 b5 b6]
        d
    end
    meanrestrain(d)=meanrestrain(d)/k; meanrestest(d)=meanrestest(d)/k;
end

figure; plot(meanrestest,'r');
[m,j]=min(meanrestest);

figure
X=ones(N,1); %d=1; %d is degree polyomial fit
        for i=1:j
            X=[X x.^i];
        end
        b=pinv(X)*y;
        yy=X*b;
    plot(x,y,'.'); xlabel('x'); ylabel('y');
    [xx,i]=sort(x)
    figure; 
    plot(x,yy,'*r'); hold on; plot(xx,yy(i),'r'); 
    plot(x,y,'ok')
    j

%         X=ones(N,1); %d=1; %d is degree polyomial fit
%         for i=1:15
%             X=[X x.^i];
%         end
%         b=pinv(X)*y;
%         yy=X*b;
% %     plot(x,y,'.'); xlabel('x'); ylabel('y');
%      [xx,i]=sort(x)
%     plot(xx,yy(i),'b'); 
% 
